<?php

global $metapagebuild, $jaw_builder_options, $metabuild;


// BAR TYPES
$jaw_builder_options['global_bar_type'] = array(
    'id' => 'bar_type',
    'type' => 'layout',
    'name' => 'Bar Type',
    "desc" =>  'Select this element&acute;s header type. <strong>DEFAULT: Theme Options -> General Settings -> Global Heading Style</strong>',
    'std' => '_default',
    "hide_if_layout" => array('shortcodes'),
    "options" => array(
        "_default" => JAW_ADMIN_URI . 'assets/images/default_title.png',
        "off" => JAW_ADMIN_URI . 'assets/images/title_off.png',
        "space" => JAW_ADMIN_URI . 'assets/images/title_off_without_space.png',
    )
);

$jaw_builder_options['global_bar_h'] = array(
    'id' => 'bar_h',
    'type' => 'toggle',
    'name' => 'H tag type',
    "hide_if_layout" => array('shortcodes'),
    'desc' => '',
    'std' => '3',
    "builder" => 'true',
    "options" => array("1" => "h1", "2" => "h2", "3" => "h3")
);

$jaw_builder_options['global_design_type'] = array(
    '_default' => JAW_ADMIN_URI . 'assets/images/default_title.png',
);

// CUSTOM LINKS
$jaw_builder_options['global_custom_link'] = array(
    'id' => 'custom_link',
    'type' => 'text',
    "hide_if_layout" => array('shortcodes'),
    'name' => '<i class="jaw-icon-link"></i> Custom Link',
    "desc" => 'Insert your custom link for title of this element.',
    'std' => '',
    
);

// ORDERBY
$jaw_builder_options['global_orderby'] = array(
    'id' => 'orderby_check_msg',
    "name" => "Warning Message",
    "text" => 'Please bear in mind that Posts that have 0 views will not be sorted',
    "type" => "info",
    "space" => false,
    "message" => "warnings",
    'ng-show' => 'edit[\'orderby\']==\'most_visited\' || edit[\'orderby\']==\'most_liked\''
);
$jaw_builder_options['global_orderby'] = array(
    'id' => 'orderby',
    'type' => 'select',
    'name' => 'Post Order by',
    "desc" => 'Order posts by parameters. Help on <a target="_blank" href="http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters">Order by Parameters</a>.',
    'std' => 'date',
    'mod' => 'medium',
    
    'options' => array(
        "date" => "Date",
        "none" => "None",
        "ID" => "ID",
        "post__in" => "By the >Post In< option",
        "author" => "Author",
        "title" => "Title",
        "modified" => "Modified",
        "parent" => "Parent",
        "rand" => "Rand",
        "comment_count" => "Comments count",
        "most_liked" => "Most Liked",
        "most_visited" => "Most Visited"
    )
);
//show on devices
$jaw_builder_options['show_on_devices'] = array(
    'id' => 'show_on_devices',
    'type' => 'toggle',
    'name' => 'Show Item on Devices',
    "desc" => 'Choose whether or not and where to show slider - either on desktop or on desktop and tablets.',
    'std' => 'all',
    "hide_if_layout" => array('shortcodes'),
    'options' => array(
        "all" => "<i class='jaw-icon-screen4'></i><i class='jaw-icon-tablet'></i><i class='jaw-icon-mobile'></i>",
        "desktop-tablet" => "<i class='jaw-icon-screen4'></i><i class='jaw-icon-tablet'></i>", 
        "phone-tablet" => "<i class='jaw-icon-tablet'></i><i class='jaw-icon-mobile'></i>",
        "only-desktop" => "<i class='jaw-icon-screen4'></i>", 
        "only-tablet" => "<i class='jaw-icon-tablet'></i>",
        "only-phone" => "<i class='jaw-icon-mobile'></i>",
    )
);
//space after element
$jaw_builder_options['space_after']  = array(
    'id' => 'space_after',
    'type' => 'toggle',
    'name' => 'Show Standart Space After',
    'desc' => 'If you don`t want to show standart 30px gap after this element',
    'std' => 'space_after',
    "options" => array("no_space_after" => "Off", "space_after" => "On")
);


//filter $jaw_builder_options
$jaw_builder_options = apply_filters('jaw_revocomposer_elements_editor',$jaw_builder_options);



//TEMPLATES ====================================================================
//HOME =========================================================================

$home[] = array(
    "name" => "Container",
    
    "id" => "build_container",
    "type" => "builder",
    
    'icon' => 'jaw-icon-insert-template',
    "size" => 12
);



$home[] = array(
    "name" => "Blog",
    
    "id" => "build_blog",
    "type" => "builder",
    "icon" => 'jaw-icon-newspaper',
    "size" => 12
);

$home[] = array(
    "name" => "Button",
    
    "id" => "build_button",
    
    "type" => "builder",
    'icon' => 'jaw-icon-radio-checked ',
    "size" => 3
);

$home[] = array(
    "name" => "Custom Text",
    
    "id" => "build_custom_text",
    "type" => "builder",
    'icon' => 'jaw-icon-pencil2',
    "size" => 12
);

$home[] = array(
    "name" => "Divider",
    "help" => array("Divider", 'Divider line over whole page'),
    "id" => "build_divider",
    "type" => "builder",
    "size" => 12,
    'icon' => 'jaw-icon-minus',
    'edit_name' => 'false'
);

$home[] = array(
    "name" => "Image",
    
    "id" => "build_image",
    "type" => "builder",
    'icon' => 'jaw-icon-image',
    "size" => 12
);

$home[] = array(
    "name" => "Inline Sidebar",
    "help" => array("Inline Sidebar", 'With this you can put widget to page content'),
    "id" => "build_page_sidebar",
    "type" => "builder",
    'icon' => 'jaw-icon-file ',
    "size" => 4
);

$home[] = array(
    "name" => "Title",
    
    "id" => "build_title",
    "type" => "builder",
    "size" => 12,
    'icon' => 'jaw-icon-type ',
    'edit_name' => 'false'
);

$home[] = array(
    "name" => "Custom Banner",
    
    "id" => "build_banner",
    "type" => "builder",
    'icon' => 'jaw-icon-file8 ',
    "size" => 12
);



$metabuild['build_bookmark_home'] = array(
    "name" => "Composer",
    
    "id" => "build_bookmark_home",
    "type" => "builder_bookmark",
    'content' => $home,
    "header" => false
);


// Slider submenu ==============================================================


$sliders[] = array(
    "name" => "Big Photo Slider",
    "help" => array("Big Photo Slider", "DO NOT use it inside fullwidth container !!!", "slider_fullwidth.png"),
    "id" => "build_slider_5",
    "type" => "builder",
    'icon' => 'jaw-icon-notebook',
    "size" => 12,
);


$sliders[] = array(
    "name" => "JaW Grid",
    "help" => array("JaW Grid", "", "grid.jpg"),
    "id" => "build_grid",
    "type" => "builder",
    'icon' => 'jaw-icon-ad',
    "size" => 12,
);


if (isset($sliders)) {
    $metabuild['build_slider'] = array(
        "name" => "Sliders",
        
        "id" => "build_slider",
        "type" => "builder_bookmark",
        'content' => $sliders,
        "header" => false
    );
}

// WOO submenu =================================================================

//filter 
$metabuild = apply_filters('jaw_revocomposer_elements', $metabuild);


// all button ==================================================================

$all_items = array();
foreach($metabuild as $key => $meta){
    if(!empty($meta['content'])){
        $all_items = array_merge($all_items, $meta['content']);
    }
}
$metabuild['build_all'] = array(
    "name" => "All",
    
    "id" => "build_all",
    "type" => "builder_bookmark",
    'content' => jwUtils::aasort($all_items, "name"),
    "header" => false
);

// LAYOUT ======================================================================
$layout[] = array(
    "name" => "Page Layout",
    
    "id" => "build_layout",
    "type" => "layout_pb",
    "extend" => 'jaw-pb-sidebar',
    "header" => false,
    "template" => 'true',
    "options" => array(
        'fullwidth' => JAW_ADMIN_URI . 'assets/images/no_sidebar.gif',
        'left1' => JAW_ADMIN_URI . 'assets/images/left_sidebar.gif',
        'right1' => JAW_ADMIN_URI . 'assets/images/right_sidebar.gif',
    )
);

$metabuild['build_layout_bookmark'] = array(
    "name" => "Page Layout",
    
    "id" => "build_layout_bookmark",
    "type" => "builder_bookmark",
    'content' => $layout,
    'icon' => 'jaw-icon-table2 ',
    "header" => false
);

// PRO
$pro[] = array(
    "name" => "PRO version",
    "id" => "build_pro",
    "type" => "info",
    "text" => "In PRO version are available over 60 elements.",
    "message" => "plain-text"
);

$metabuild['build_pro_bookmark'] = array(
    "name" => "PRO version",
    "id" => "build_pro_bookmark",
    "type" => "builder_bookmark",
    'content' => $pro,
    'icon' => 'jaw-icon-star4',
    "header" => false
);

$submetabuild = array();
$submetabuild[] = array(
    "name" => "Builder",
    
    "id" => "jaw_pb",
    "type" => "jaw_builder",
    "areas" => "{
                'content': [
                    {'id': '2_content', 'type': 'content', 'size': 12},
                    {'id': '1_header', 'type': 'content', 'size': 12}
                ],
                'sidebar': [
                    {'id': 'sidebar_left1', 'type': 'sidebar', 'size': 2, 'visible': false},
                    {'id': 'sidebar_left2', 'type': 'sidebar', 'size': 2, 'visible': false},
                    {'id': 'sidebar_right1', 'type': 'sidebar', 'size': 2, 'visible': false},
                    {'id': 'sidebar_right2', 'type': 'sidebar', 'size': 2, 'visible': false}
                ]
            }", 
    'content' => $metabuild
);

$metapagebuild = array(
    "id" => "jaw_page_builder",
    "type" => "page_builder",
    "title" => "RevoComposer", //"Ultra Mega Awesome Greatest Smartest Page builder",
    "pages" => array('page'),
    "context" => "normal", //Optional. The context within the page where the boxes should show ('normal', 'advanced')
    "priority" => "high", //Optional. The priority within the context where the boxes should show ('high', 'low').
    "help" => null,
    "class" => "jw-hidden", //javascript tento metabox prenasi jinam - v klasicke poloze jej chceme skryt
    "fields" => $submetabuild
);

