<?php
/**
* Base loader and theme initialization
*
* @author JaW Templates <http://www.jawtemplates.com>
* @copyright (c) 2013, CCB, spol. s r.o.
* @version 1.0
*/
if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}
// 
// 
add_action('admin_menu', 'jaw_lite_init');
function jaw_lite_init() {
	add_theme_page(
    "G'Day News Demo Content",
    "G'Day News Demo Content",
    'read',
    'jaw-hello-screen',
    'jawDemoScreenContent');
}
function jawDemoScreenContent() {
    echo "<div class='wrap' ng-app='jwEditor'>";
    echo "<h2></h2>";   
    $installedDemos = jwUtils::jsonEncode(array_flip(array_keys(jwDemoImport::getWholeLog())));?>
    <div id='of_container' class='jaw-welcome-tutorial section jw_option'>
    <div class="jw-lite">
    <h2>Demo Content Installation</h2>
    <jwd-info-dialog></jwd-info-dialog>
    <jwd-demo demos="{\'demo02\':\'Men`s magazine\'}" installed="{{installedDemos}}" ng-init="installedDemos = '<?php echo $installedDemos; ?>'"></jwd-demo>
    <div class="clear"></div>
    </div>
    </div>
    <?php
    echo "</div>";
    echo '<input type="hidden" id="jaw_security" class="jaw_nonce" name="jaw_security" value="'. wp_create_nonce('of_ajax_nonce'). '" />';
}
// 

add_action('after_setup_theme', 'jaw_language');
add_action('after_setup_theme', 'jaw_theme_supports');
add_action('init', 'jaw_init', 0);
// Load admin options
if(is_admin()) {
    add_action('init', 'jaw_admin_start', 1);
}

// Goodstore Welcome Page
add_action('admin_init', 'jaw_welcome');

//We are using our own responsive images so disable WordPress solution
add_filter( 'wp_calculate_image_srcset', 'jaw_disable_srcset' );

add_action('init', 'jaw_controll_responsive');

/* ===========================================================================================
*                                          INIT THEME
* ==========================================================================================*/
function jaw_init() {
    
    // Define constants.
    jaw_constants();
    
    // Load framework.
    jaw_libs();
    
    //add hooks
    jaw_hooks();
    
    //start theme
    jaw_start();
}

function jaw_hooks(){
    // Add css
    add_action('wp_enqueue_scripts', 'jaw_css', 50);
    add_action('admin_enqueue_scripts', 'jaw_admin_css', 50);
    
    // Add js
    add_action('wp_enqueue_scripts', 'jaw_wp_scripts');
    add_action('admin_enqueue_scripts', 'jaw_admin_scripts',1);
    
    //header
    add_action('wp_head', array('jwUtils', 'get_social_meta'),5);
    add_action('wp_head', array('jwUtils', 'setTelAutodetection'),5);
    add_action('wp_head', array('jwUtils', 'header'), 0);
    add_action('admin_head', array('jwUtils', 'admin_header'), 0);    
    
    //Footer
    add_action('wp_footer', array('jwUtils', 'footer_socials'));
    add_action('wp_footer', array('jwUtils', 'footer_google_fonts'),99);
    
    //Body class
    add_filter('body_class', array('jwUtils', 'body_class'));
    
    //Post class
    add_filter('post_class', array('jwUtils', 'post_class'));
       
    //ukoncovac excerptu
    add_filter('excerpt_more', 'jaw_excerpt_more');
    
    // init cache
    if (!file_exists(WP_CONTENT_DIR . '/cache/') && function_exists('mkdir') && is_writable(WP_CONTENT_DIR . '/cache/')) {
        mkdir(WP_CONTENT_DIR . '/cache');
    }
    
// 

    //sidebar manager
    add_action('wp_ajax_jaw_add_sidebar', array('jwElements', 'jaw_add_sidebar'));

    //increase reader AJAX
    add_action('wp_ajax_jaw_increase_readers_count', array('jwUtils', 'increase_readers_count'),99);
    add_action('wp_ajax_nopriv_jaw_increase_readers_count', array('jwUtils', 'increase_readers_count'),99);
    
    //dulezity pro revoComposer - jinak se bude printovat i v hlavicce
    add_filter('get_the_excerpt', 'jaw_excerpt_strip_shortcodes', 5);
        
    //TINY MCE
    add_filter('mce_buttons_2', array('jwUtils', 'jaw_mce_buttons_2'));
    
    // RSS - pridani attachmentu
    add_filter('rss2_item', 'jaw_rss_post_thumbnail');
    add_filter('rss_item', 'jaw_rss_post_thumbnail');
    add_filter('the_excerpt_rss', 'jaw_rss_noi_frame');
    add_filter('the_content_feed', 'jaw_rss_noi_frame');

    // add noscript before script tag 
    add_filter( 'style_loader_tag', 'jaw_style_loader_tag', 10, 3 );

    //post boxes
    add_action("jaw_postbox_classical", array("jwRender", "postboxTitle"), 5, 1);
    add_action("jaw_postbox_classical", array("jwRender", "postboxExcerpt"), 10, 1);
    add_action("jaw_postbox_classical", array("jwRender", "postboxMeta"), 15, 1);

    add_action("jaw_postbox_simple", array("jwRender", "postboxTitle"), 5, 1);
    add_action("jaw_postbox_simple", array("jwRender", "postboxMeta"), 15, 1);

    add_action("jaw_postbox_vertical", array("jwRender", "postboxTitle"), 5, 1);
    add_action("jaw_postbox_vertical", array("jwRender", "postboxExcerpt"), 10, 1);
    add_action("jaw_postbox_vertical", array("jwRender", "postboxMeta"), 15, 1);

    add_action("jaw_postbox_vertical_small", array("jwRender", "postboxTitle"), 5, 1);
    add_action("jaw_postbox_vertical_small", array("jwRender", "postboxExcerpt"), 10, 1);
    add_action("jaw_postbox_vertical_small", array("jwRender", "postboxMeta"), 15, 1);

    add_action("jaw_postbox_vertical_big", array("jwRender", "postboxTitle"), 5, 1);
    add_action("jaw_postbox_vertical_big", array("jwRender", "postboxExcerpt"), 10, 1);
    add_action("jaw_postbox_vertical_big", array("jwRender", "postboxMeta"), 15, 1);
}


function jaw_start(){
    
    // Zavedeni optu
    new jwOpt();
    
    //INIT JAW plugins
    jaw_init_plugins();
    
    //posts likes
    new jwLikes();
    
    // register sidebar
    new jwSidebars(jwOpt::get_option('sidebars'), null);
    
    if (jwOpt::get_option('theme_revoComposer', '1') == '1') {
        // Zavedeni RevoComposeru
        new jwBuilder();
    }
    
    //jaw translation
    if(jwOpt::get_option('use_translation', '0')){
        //_x, _ex, esc_attr_x, esc_html_x to zatim neumi
        add_filter( 'gettext', array('jwUtils', 'jaw_translation'), 10, 3);
        add_filter( 'ngettext', array('jwUtils', 'jaw_ntranslation'), 10, 5);
    }
        
    //redirect after login
    if(jwOpt::get_option('user_bar_login_pageid', '_default') != '_default'){
        //redirect for subscribers
        add_filter( 'login_redirect', 'jaw_login_redirect', 10, 3 );
    }
    //redirect after WRONG login
    if(jwOpt::get_option('user_bar_wrong_login_pageid', '_default') != '_default'){
        add_action('wp_login_failed', 'jaw_redirect_login_failed');
    }

    // CUSTOMIZE theme API - color scheme
    if(function_exists('is_customize_preview') && is_customize_preview()){
        new jwCustomizer();
    }

    if (is_admin()) {
        //Check write to file
        jwUtils::check_write_to_file();
    }

    // REGISTER new user
    if (!is_admin()) {
        if (filter_input(INPUT_POST, 'jaw-register') !== null) {
            jwUtils::register_new_user();
        }
    }

    // uzvatelsky zavisly obsah
    if (is_user_logged_in()) {
        jwInterest::bootstrap();
    }

    //odstraneni spanu class="more". Kdyz byl za <more> vlozeny shortcode, zpusoboval prazdny p tag za <more>.
    add_filter('the_content', 'jaw_remove_more_span', 12);

    // Comments - Anti-spam filter
    if (jwOpt::get_option('comments_antispam_toggle', '0') == '1') {
        add_filter('preprocess_comment', array('jwUtils', 'jaw_nobot_question_filter'));
    }
    
    //cache - verions of assets
    if(jwOpt::get_option('cache', '1') === '1'){
        add_filter( 'style_loader_src', 'jaw_remove_wp_ver_css_js', 9999 );
        add_filter( 'script_loader_src', 'jaw_remove_wp_ver_css_js', 9999 );
    }

    // ???
    add_filter('tiny_mce_before_init', 'jaw_add_i_frame');
    include_once ABSPATH . '/wp-admin/includes/nav-menu.php';
    load_template(ABSPATH . 'wp-admin/includes/image.php');


    // Po instalaci sablony se nastavi zakladni parametry.
    $jaw_install = get_option('jaw_install');
    if ($jaw_install == null) {
       jaw_after_install_theme();
    }
    if ($jaw_install < 3 && is_admin()  && current_user_can('install_plugins')) {
       $jwWelcome = new jwWelcome();
    }

    if(false){
        $thumbnail = get_the_post_thumbnail('thumbnail'); //@todo odstranit
    }

    // image cropping
    // because image sizes are registered in after_setup_theme - too early for jwOpt
    update_option('img_cropping', esc_attr(jwOpt::get_option("image_cropping", 1))); 
}

// Load admin options
function jaw_admin_start(){
    //styles
    add_action('jaw_generate_styles', 'jaw_generate_styles', 10, 1);
    //pri importu dema neukladej metaboxy
    add_action('import_start', 'jaw_deregister_generate_styles',12);
     
    // Zavedeni theme optionsu
    new jwPanel();

    ///vypnuti JaW cache
    if(jwOpt::get_option( 'cache', '0' )) {
        jwOpt::update_option( 'cache', '0' );
        add_action( 'admin_notices', 'jaw_cache_turnoff' );
    }
    
    
    //Nacteni metaboxu, metapage a metacat
    load_template(JAW_ADMIN_DIR . 'options/metaboxes.php', true);
    
    // 
    
    load_template(JAW_ADMIN_DIR . 'options/color_preset.php', true);
    
    global $metapost, $metacat, $metapage, $metapostformats;
    
    new jwMetabox($metapost);
    new jwMetabox($metapage);
    new jwMetabox($metapostformats);
    
    new jwMetatax($metacat, 'category');
    
    
    if (jwOpt::get_option('switch_udate', '1') == '1') {
        
        // Overeni updatu sablony
        new ThemeUpdateChecker(
        JAW_THEMESLUG, 'http://support.jawtemplates.com/info/update.php'
        );
    }
}
/*=======================================END================================================*/





/* ===========================================================================================
*                          ADD COLORS PREVIEW TO CATEGORY LIST
* ==========================================================================================*/
add_filter('manage_edit-category_columns', 'jaw_manage_my_category_columns');
add_filter('manage_category_custom_column', 'jaw_column_return_value', 10, 3);

function jaw_manage_my_category_columns($columns) {
    $columns['jaw-color'] = esc_html__('Color', "gdn-theme");
    return $columns;
}

function jaw_column_return_value($value, $columnName, $taxonomyId = 0) {
    if ($columnName == 'jaw-color') {
        $preset = jwOpt::checkDefaultPreset(array(jwOpt::get_option("content_color", "_default", "category", $taxonomyId), jwOpt::get_option("main_color")),'color');
            $presets = jwOpt::loadPreset('color', $preset);
            $finalPreset1 = '#ffffff';
            $finalPreset2 = '#000000';
            $finalPresetName = 'Please set Main Color Scheme in Theme Options -> Color Settings';
            if (isset($presets['theme1']) && isset($presets['theme3']) && isset($presets['title'])) {
                $finalPreset1 = $presets['theme1'];
                $finalPreset2 = $presets['theme3'];
                $finalPresetName = $presets['title'];
        } else {
            $presets = jwOpt::loadPreset('color', jwOpt::get_option("main_color"));
            if(isset($presets['theme1']) && isset($presets['theme3']) && isset($presets['title'])){
                $finalPreset1 = $presets['theme1'];
                $finalPreset2 = $presets['theme3'];
                $finalPresetName = $presets['title'];
            }
        }
    $value = '<div style="text-align:center;box-shadow: 0 1px 6px 0 rgba(0,0,0,.12),0 1px 6px 0 rgba(0,0,0,.12); }display: block;padding: 15px;background-color:' . $finalPreset1 . '"><a href="' . JAW_SITE_URL . '/wp-admin/edit-tags.php?action=edit&taxonomy=category&tag_ID=' . $taxonomyId . '#section-content_color"><span style="color:' . $finalPreset2 . ';">' . $finalPresetName . '</span></a></div>';
}

return $value;
}
/*=======================================END================================================*/





/* ===========================================================================================
*                          ADD COLORS PREVIEW TO PAGE LIST
* ==========================================================================================*/

add_filter('manage_edit-page_columns', 'jaw_manage_my_page_columns');
add_action('manage_pages_custom_column', 'jaw_custom_set_pages_columns_page_id', 10, 2);

function jaw_manage_my_page_columns($columns) {
    $columns['jaw-page-color'] = esc_html__('Color', "gdn-theme");
    return $columns;
}

function jaw_custom_set_pages_columns_page_id($columnName, $pageId) {
    if ($columnName == 'jaw-page-color') {
        $preset = jwOpt::checkDefaultPreset(array(get_post_meta($pageId, 'jaw_page_color', true), jwOpt::get_option("main_color")),'color');
        $presets = jwOpt::loadPreset('color', $preset);
        $finalPreset1 = '#ffffff';
        $finalPreset2 = '#000000';
        $finalPresetName = 'Please set Main Color Scheme in Theme Options -> Color Settings';
        if (isset($presets["theme1"]) && isset($presets["theme3"]) && isset($presets["title"])) {
            $finalPreset1 = $presets["theme1"];
            $finalPreset2 = $presets["theme3"];
            $finalPresetName = $presets["title"];
        } else {
            $presets = jwOpt::loadPreset('color', jwOpt::get_option("main_color"));
            if(isset($presets["theme1"]) && isset($presets["theme3"]) && isset($presets["title"])){
                $finalPreset1 = $presets["theme1"];
                $finalPreset2 = $presets["theme3"];
                $finalPresetName = $presets["title"];
            }
        }
    echo '<div style="text-align:center;box-shadow: 0 1px 6px 0 rgba(0,0,0,.12),0 1px 6px 0 rgba(0,0,0,.12); }display: block;padding: 15px;background-color:' . $finalPreset1 . '"><a href="' . JAW_SITE_URL . '/wp-admin/post.php?post=' . $pageId . '&action=edit#section-jaw_page_color"><span style="color:' . $finalPreset2 . ';">' . $finalPresetName . '</span></a></div>';
}
}

/*=======================================END================================================*/

function jaw_rss_noi_frame($content) {
    $content = preg_replace('/<iframe(.*)\/iframe>/is', '', $content);
    
    return $content;
}

function jaw_rss_post_thumbnail() {
    global $post;
    if (has_post_thumbnail($post->ID)) {
        $img = wp_get_attachment_image_src(get_post_thumbnail_id($post->ID), "jaw_blog-16_9");
        if (isset($img[0])) {
            list($width, $height, $type, $attr) = getimagesize($img[0]);
            echo '<enclosure url="' . $img[0] . '" type="' . image_type_to_mime_type($type) . '" length="1" />';
        }
    }
}

function jaw_add_i_frame($initArray) {
    $initArray['extended_valid_elements'] = "iframe[id|class|title|style|align|frameborder|height|longdesc|marginheight|marginwidth|name|scrolling|src|width]";
    return $initArray;
}

function jaw_theme_supports() {
    
    $autocrop = 0;
    if (get_option("img_cropping") == 1) {
        add_image_size('jaw_slider-square', 500, 500, true); // 1:1
        add_image_size('jaw_blog-special', 275, 275, true); // 1:1
        add_image_size('jaw_blog-16_9-big', 878, 494, true); // 16:9
        add_image_size('jaw_blog-16_9', 475, 267, true); // 16:9
        add_image_size('jaw_blog-16_9-middle', 270, 152, true); // 16:9
        add_image_size('jaw_blog-16_9-small', 170, 95, true); // 16:9
        add_image_size('jaw_blog-mini', 72, 49, true);
    } else {
        add_image_size('jaw_slider-square', 500, $autocrop, true);
        add_image_size('jaw_blog-special', 275, $autocrop, true);
        add_image_size('jaw_blog-16_9-big', 878, $autocrop, true);
        add_image_size('jaw_blog-16_9', 475, $autocrop, true);
        add_image_size('jaw_blog-16_9-middle', 270, $autocrop, true);
        add_image_size('jaw_blog-16_9-small', 170, $autocrop, true);
        add_image_size('jaw_blog-mini', 72, $autocrop, true);
    }
    
    
    
    if (function_exists('add_theme_support')) {
        
        // Add post thumbnail supports. http://codex.wordpress.org/Post_Tphumbnails
        add_theme_support('post-thumbnails');
        
        // Add post formarts supports. http://codex.wordpress.org/Post_Formats
        add_theme_support('post-formats', array('gallery', 'image', 'quote', 'video', 'link'));
        
        // Add menu supports. http://codex.wordpress.org/Function_Reference/register_nav_menus
        add_theme_support('menus');
        register_nav_menus(array(
        'primary_navigation' => esc_html__('Primary Navigation', "gdn-theme"),
        'primary_mobile_navigation' => esc_html__('Primary Mobile Navigation', "gdn-theme"),
        'top_bar_navigation' => esc_html__('Top Bar Navigation', "gdn-theme"),
        'footer_navigation' => esc_html__('Footer Navigation', "gdn-theme"),
        ));
        
        add_editor_style('/css/editor-style.css');
        
        //This enables post and comment RSS feed links to head. This should be used in place of the deprecated automatic_feed_links.
        add_theme_support('automatic-feed-links');
        
        // reference to: http://codex.wordpress.org/Function_Reference/add_editor_style
        add_theme_support('editor-style');
        
        //Themeforrest requipments
        add_theme_support('custom-header', array(
        'default-image' => '',
        'random-default' => false,
        'width' => 1040,
        'flex-height' => true,
        'flex-width' => true,
        'uploads' => true,
        'header-text' => false
        ));
        add_theme_support('custom-background');
        
        add_theme_support( "title-tag" );
    }
}

function jaw_disable_srcset( $sources ) {
    return false;
}

//PLUGINS*****************
$jawPluginName = '';

function jaw_init_plugins() {
    
    //   if (is_admin()) {
    if ($plugins = jwOpt::getXmlSpace('plugins')) {
        foreach ($plugins->children() as $plugin) {
            $name = (string) $plugin->attributes()->name;
            $theme = wp_get_theme();
            
            if (class_exists($name) && method_exists($name, 'getInstance')) {
                
                $result = call_user_func($name . '::getInstance');
                $result->init($plugin, $theme);
                
                if ($result == false) {
                    $jawPluginName = $name;
                    add_action('admin_notices', 'jaw_admin_notice');
                }
            }
        }
    }
    // }
}

function jaw_admin_notice() {
    ?>
    <div class="updated">
        <p><b><?php echo esc_html($jawPluginName); ?>:</b><?php esc_html_e(" This version of plugin is not supported for your theme",'gdn-theme'); ?></p>
    </div>
    <?php
}

//vypnuti JaW Cache
function jaw_cache_turnoff() {
    ?>
    <div class="notice notice-warning is-dismissible">
        <p><?php esc_html_e("Plugin JaW Cache has been deprecated. Please use some alternative. E.g. WP Super Cache.",'gdn-theme'); ?></p>
    </div>
    <?php
}

// SEO DUPLICITE WARNING MESSAGE
function jaw_seo_dupl_warning_msg() {
    if(function_exists("wpseo_auto_load") && jwOpt::get_option('use_jaw_seo', '1') == '1') {
        $otherseotext = '<i class="jaw-icon-warning"></i><span style="color:red">
        '.esc_html__("You have activated Another SEO Plugin. We suggest you to turn built-in SEO via Theme Options or you can disable SEO plugin",'gdn-theme').
        '<a target="_blank" href="'.admin_url('plugins.php').'">
        '.esc_html__("here",'gdn-theme').'</a> 
        '.esc_html__("Please bear in mind that for the best results we recommend use only one SEO (plugin or built-in) and not both. Thank you.",'gdn-theme').' </span>';
        $class = 'notice notice-error';
        printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $otherseotext ); 
    }
}
add_action( 'admin_notices', 'jaw_seo_dupl_warning_msg' );

/*
* Load constants
*/
function jaw_constants() {
    
    $JAW_THEMEVERSION = '';
    $JAW_THEMENAME = "GDN Theme";
    
    if (function_exists('wp_get_theme')) {
        
        if (is_child_theme()) {
            $tempObj = wp_get_theme();
            $themeObj = wp_get_theme($tempObj->get('Template')); // nactu info o main theme 
        } else {
            $themeObj = wp_get_theme();
        }
        
        $JAW_THEMEVERSION = $themeObj->get('Version');
// #IF JAW_PR
        $JAW_THEMENAME = $themeObj->get('Name');
// 
    } else { // for WP < 3.4.0
        $themeData = wp_get_theme(get_template_directory() . '/style.css');
        $JAW_THEMEVERSION = $themeData['Version'];
// 
    }


    //PHP<5.4
    if(!defined('JSON_UNESCAPED_UNICODE')){
        define('JSON_UNESCAPED_UNICODE', 256);
    }
    
    define('JAW_SITE_URL', get_option('siteurl'));
    
    define('JAW_THEMENAME', $JAW_THEMENAME);
    define('JAW_THEMESLUG', strtolower($JAW_THEMENAME));
    define('JAW_THEMEVERSION', $JAW_THEMEVERSION);
    
    define('JAW_THEME_FRAMEWORK_DIR', get_template_directory() . '/framework');
    define('JAW_THEME_FRAMEWORK_URI', get_template_directory_uri() . '/framework');
    define('JAW_THEME_FRAMEWORK_LIB', JAW_THEME_FRAMEWORK_DIR . '/lib/');
    
    define('JAW_ADMIN_DIR', JAW_THEME_FRAMEWORK_DIR . '/admin/');
    define('JAW_ADMIN_URI', JAW_THEME_FRAMEWORK_URI . '/admin/');
    
    define('JAW_THEME_DIR', get_template_directory());
    define('JAW_THEME_URI', get_template_directory_uri());
    
    if (!defined('WP_CONTENT_DIR')) {
        define('WP_CONTENT_DIR', realpath(JAW_THEME_DIR . '/../..'));
    }
    
    /* Theme version, uri, and the author uri are not completely necessary, but may be helpful in adding functionality */
    define('JAW_CATEGORIES', JAW_THEMESLUG . '_categories');
    define('JAW_MENUS', JAW_THEMESLUG . '_menus');
    define('JAW_OPTIONS', JAW_THEMESLUG . '_options');
    define('JAW_BACKUPS', '_backups');
    
    define('JAW_COLOR_LOG', JAW_THEMESLUG . '-log');
    
    define('JAW_CHECK_UPDATE', 1209600); //86400*14 = 1209600
    define('JAW_THEME_FUNCTIONS', JAW_THEME_FRAMEWORK_DIR . '/functions');
}

/*
* Load basic classes
*/

function jaw_libs() {
    if(is_admin()){
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_builderhelper.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_lessc.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_styles.php', true);
    }
    if(function_exists('is_customize_preview') && is_customize_preview()){
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_customizer.php', true);
    }
    load_template(ABSPATH . 'wp-admin/includes/plugin.php'); //abych mohl pouzivat is_plugin_active
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_options.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_layout.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_utils.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_sidebars.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_render.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_builder.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_shortcodes.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'jaw-templater.php', true);
    //locate_template(array('tmpl/template.php'), true); @rami - 13.3.2017 zruseno pro snadnejsi customizaci useru
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_media.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_interest.php', true);
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_likes.php', true);
    
// 
    load_template(JAW_THEME_FRAMEWORK_LIB . 'class_facebook.php', true);
    
    if (is_admin()) {
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_updatechecker.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_elements.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_panel.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_demoimport.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_metatax.php', true);
        load_template(JAW_THEME_FRAMEWORK_LIB . 'class_metabox.php', true);
        if(current_user_can('install_plugins')){
            load_template(JAW_THEME_FRAMEWORK_LIB . 'class_tgm.php', true);
            load_template(JAW_THEME_FRAMEWORK_LIB . 'class_welcome.php', true);      
        }
    }
}

/*
* Make theme available for translation
*/

function jaw_language() {
    load_theme_textdomain("gdn-theme", get_template_directory() . '/languages/');
}

function jaw_css() {
    
    wp_register_style('style', get_stylesheet_directory_uri() . '/style.css', array(), jwUtils::assetsVersion());
    wp_enqueue_style('style');
    
    wp_register_style('template_min', get_template_directory_uri() . '/css/template.min.css', array(), jwUtils::assetsVersion());
    wp_enqueue_style('template_min');


    $version = get_option('jaw_custom_css_version');
    $blogId = get_current_blog_id();
    if(function_exists('is_customize_preview') && is_customize_preview()){
        wp_register_style('themeoptions-preview', get_template_directory_uri() . '/css/themeoptions-' . $blogId . '-preview.css', array('template_min'), $version);
        wp_enqueue_style('themeoptions-preview');
    }else{
        wp_register_style('themeoptions', get_template_directory_uri() . '/css/themeoptions-' . $blogId . '.css', array('template_min'), $version);
        wp_enqueue_style('themeoptions');
    }

    //Google fonts
    wp_enqueue_style( 'jaw-google-fonts', jwUtils::loadFonts(), array(), $version );
    
    // < IE9
    wp_register_style('old-ie', get_template_directory_uri() . '/css/old-ie.min.css', array('template_min'), $version);
    wp_enqueue_style('old-ie');
    wp_style_add_data( 'old-ie', 'conditional', 'lt IE 9' );
    wp_register_style('noscript', get_template_directory_uri() . '/css/noscript.min.css', array('template_min'), $version);
    wp_enqueue_style('noscript');
    wp_style_add_data( 'noscript', 'conditional', 'lt IE 9' );
    
    //noscript
    wp_register_style('jaw_noscript', get_template_directory_uri() . '/css/noscript.min.css', array(), $version);
    wp_enqueue_style('jaw_noscript');

    //styles from /custom_styles/ folder are compiled by jwStyles (Theme Options)
}

function jaw_admin_css() {                
    wp_register_style('jaw-admin-style', JAW_ADMIN_URI . 'assets/css/admin-style.css', array(), jwUtils::assetsVersion());
    wp_enqueue_style('jaw-admin-style');
    
    wp_register_style('colorpicker', JAW_ADMIN_URI . 'assets/css/colorpicker.css', array(), jwUtils::assetsVersion());
    wp_enqueue_style('colorpicker');
    
    wp_register_style('jaw-icons', get_template_directory_uri() . '/css/icons.css', jwUtils::assetsVersion());
    wp_enqueue_style('jaw-icons');
}



function jaw_wp_scripts() {
    
    wp_register_script('jaw_all', get_template_directory_uri() . '/js/all.js', array('jquery'), jwUtils::assetsVersion(), true);
    wp_enqueue_script('jaw_all');
    
    wp_register_script('jaw_app', get_template_directory_uri() . '/js/app.min.js', array('jquery', 'jaw_all'), jwUtils::assetsVersion(), true);
    wp_enqueue_script('jaw_app');
    
    wp_localize_script('jaw_app', 'ajax_object', array('ajax_url' => admin_url('admin-ajax.php'), 'ajax_nonce' => wp_create_nonce()));
    
    if(jwOpt::get_option('preload_google_fonts', '1')){
        wp_register_script('google_webfont', '//ajax.googleapis.com/ajax/libs/webfont/1.5.18/webfont.js', false, false, true);
        wp_enqueue_script('google_webfont');
    }
    
    // Enable threaded comments
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }

    // < IE9
    wp_register_script('html5shim', get_template_directory_uri() . '/js/html5shiv.min.js', array(), jwUtils::assetsVersion('3.7.3'), true);
    wp_enqueue_script('html5shim');
    wp_script_add_data( 'html5shim', 'conditional', 'lt IE 9' );
}

function jaw_admin_scripts() {
    wp_enqueue_media();
    
    wp_enqueue_script('jquery-ui-core', array('jquery'));
    wp_enqueue_script('jquery-ui-sortable', array('jquery'));
    wp_enqueue_script('jquery-ui-slider', array('jquery'));
    wp_enqueue_script('jquery-ui-mouse', array('jquery'));
    wp_enqueue_script('media-upload', array('jquery'));
    wp_enqueue_script('thickbox', array('jquery'));
    
    wp_enqueue_script('ace_editor', JAW_ADMIN_URI . 'assets/js/ace_editor/ace.js', array('jquery'), jwUtils::assetsVersion());
    wp_enqueue_script('ext-language_tools', JAW_ADMIN_URI . 'assets/js/ace_editor/ext-language_tools.js', array('jquery', 'ace_editor'), jwUtils::assetsVersion());
    wp_enqueue_script('ext-emmet', JAW_ADMIN_URI . 'assets/js/ace_editor/ext-emmet.js', array('jquery', 'ace_editor'), jwUtils::assetsVersion());

    wp_enqueue_script('jawAdminApp', JAW_ADMIN_URI . 'assets/js/app.min.js', array('jquery', 'ace_editor'), jwUtils::assetsVersion()); 
     
    $jawVariables = array();
    $jawVariables['optionsframework_url'] = admin_url("?page=optionsframework");
    $jawVariables['JAW_THEME_URI'] = JAW_THEME_URI;
    if(defined('JAW_DEBUG')){
        $jawVariables['JAW_DEBUG'] = JAW_DEBUG;
    }
    wp_localize_script('jawAdminApp', 'jaw_variables', $jawVariables);

}

function jaw_style_loader_tag( $tag, $handle, $src){
    if($handle == 'jaw_noscript'){
        return '<noscript>'.$tag.'</noscript>';
    }
    return $tag;
}


//pokud bude v exceprtu (more...) tak se to muze rezat spatne - thanks to audio46
function jaw_excerpt_strip_shortcodes($content) {
    return strip_shortcodes($content);
}


function jaw_welcome() {  
    $lastVersion = get_option('jaw-theme-version');
    $currentVersion = JAW_THEMEVERSION;
    if ($lastVersion != $currentVersion) {
        update_option('jaw-theme-version', jaw_get_theme_version());
        delete_option(JAW_THEMESLUG . '_last_update_check'); //opet se zeptam na novou verzi
    }
}

// 

// get version of the theme
// remove this function and add constant here
function jaw_get_theme_version() {
    
    if (is_child_theme()) {
        $tempObj = wp_get_theme();
        $themeObj = wp_get_theme($tempObj->get('Template'));
    } else {
        $themeObj = wp_get_theme();
    }
    $JAW_THEMEVERSION = $themeObj->get('Version');

    return $JAW_THEMEVERSION;
}

function jaw_controll_responsive() {
    
    if (filter_input(INPUT_COOKIE, 'jaw_responsive') !== null) {
        jwOpt::set_option('responsive', esc_attr(filter_input(INPUT_COOKIE, 'jaw_responsive')));
    }
    
    if (filter_input(INPUT_GET, 'jaw_responsive') !== null) {
        if (filter_input(INPUT_GET, 'jaw_responsive') === '1') {
            $responsive = '0';
        } else {
            $responsive = '1';
        }
        jwOpt::set_option('responsive', esc_attr($responsive));
        setcookie('jaw_responsive', $responsive, time() + 3600, COOKIEPATH, COOKIE_DOMAIN);
    }
}

function jaw_excerpt_more($more) {
    return ' ';
}

function jaw_redirect_login_failed() {
    wp_redirect(get_permalink(esc_attr(jwOpt::get_option('user_bar_wrong_login_pageid', '_default'))));
        die();
}

function jaw_login_redirect( $redirectTo, $request, $user ) {
    //is there a user to check?
    global $user;
    if ( isset( $user->roles ) && is_array( $user->roles ) ) {
        //check for admins
        if ( in_array( 'administrator', $user->roles ) || in_array( 'author', $user->roles ) || in_array( 'editor', $user->roles )) {
            // redirect them to the default place
            return $redirectTo;
        } else {
            return get_permalink(jwOpt::get_option('user_bar_login_pageid', '_default'));
        }
    } else {
        return $redirectTo;
    }
}


function jaw_remove_more_span($content){
	global $post;
	if(!is_single()){
		return $content;
	}
	return str_replace('<span id="more-' . $post->ID . '"></span>', '', $content);
}

function jaw_after_install_theme(){
   
   
    // Vytvoreni termu pro hlavni MENU.
    $insertTerm = wp_insert_term(
        'Menu - Default', 
        'nav_menu', 
        array(
            'description' => 'Base menu',
            'slug' => 'jaw-default-menu',
            'parent' => ''
        )
    );
    
    $mymenu = wp_get_nav_menu_object('jaw-default-menu');
    $menuID = (int) $mymenu->term_id;

    //pokud toto menu jiz existuje - tak to vrati ERROR, a zadna polozka se neprida.
    if(!$insertTerm instanceof WP_Error ){       
        
        $customItem = array(
        'menu-item-type' => 'custom',
        'menu-item-url' => get_option('siteurl'),
        'menu-item-title' => 'Home',
        'menu-item-status' => 'publish'
        );
        
        wp_update_nav_menu_item($menuID, 0, $customItem);    
    }

    $insertMenu = array('primary_navigation' => $menuID, 'primary_mobile_navigation' => $menuID);
    register_nav_menu('primary_navigation', 'Primary Navigation');
    register_nav_menu('primary_mobile_navigation', 'Primary Mobile Navigation');
    set_theme_mod('nav_menu_locations', $insertMenu);
    
    //end MENU
    
    //defaultni options
    $defaultOptions = array();

//    - pro lite verzi budeou defaultni barvy z dema 02
    $defaultOptions['jaw_color_preset'] = 'a:6:{s:16:"ts_0020000000000";a:15:{s:10:"background";s:7:"#ffffff";s:6:"theme1";s:7:"#17343F";s:6:"theme2";s:7:"#0A242E";s:6:"theme3";s:7:"#ffffff";s:6:"border";s:7:"#dcdcdc";s:4:"text";s:7:"#111111";s:4:"meta";s:16:"rgba(89,89,89,1)";s:4:"link";s:7:"#01354B";s:5:"hover";s:7:"#33607a";s:5:"input";s:7:"#0A242E";s:8:"input_bg";s:7:"#ffffff";s:5:"title";s:11:"Main Colors";s:22:"alternative_background";s:7:"#e8e8e8";s:9:"text_link";s:7:"#444444";s:10:"text_hover";s:7:"#009de0";}s:16:"ts_0020000000020";a:15:{s:10:"background";s:7:"#0A242E";s:6:"theme1";s:7:"#0d404f";s:6:"theme2";s:7:"#f0f0f0";s:6:"theme3";s:7:"#ffffff";s:6:"border";s:19:"rgba(255,255,255,1)";s:4:"text";s:19:"rgba(247,247,247,1)";s:4:"meta";s:7:"#ffffff";s:4:"link";s:19:"rgba(255,255,255,1)";s:5:"hover";s:7:"#cfd4e8";s:5:"input";s:7:"#444444";s:8:"input_bg";s:7:"#ffffff";s:5:"title";s:11:"Menu Colors";s:22:"alternative_background";s:7:"#0A242E";s:9:"text_link";s:7:"#444444";s:10:"text_hover";s:7:"#009de0";}s:16:"ts_0020000000021";a:15:{s:10:"background";s:7:"#0A242E";s:6:"theme1";s:7:"#0d404f";s:6:"theme2";s:7:"#0A242E";s:6:"theme3";s:7:"#ffffff";s:6:"border";s:19:"rgba(255,255,255,1)";s:4:"text";s:19:"rgba(247,247,247,1)";s:4:"meta";s:7:"#ffffff";s:4:"link";s:19:"rgba(255,255,255,1)";s:5:"hover";s:7:"#cfd4e8";s:5:"input";s:7:"#444444";s:8:"input_bg";s:7:"#ffffff";s:5:"title";s:14:"Submenu Colors";s:22:"alternative_background";s:7:"#0A242E";s:9:"text_link";s:7:"#444444";s:10:"text_hover";s:7:"#009de0";}s:16:"ts_0020000000042";a:15:{s:10:"background";s:7:"#000000";s:6:"theme1";s:7:"#D03322";s:6:"theme2";s:7:"#0A242E";s:6:"theme3";s:7:"#ffffff";s:6:"border";s:19:"rgba(255,255,255,1)";s:4:"text";s:7:"#ffffff";s:4:"meta";s:7:"#ffffff";s:4:"link";s:19:"rgba(255,255,255,1)";s:5:"hover";s:7:"#008584";s:5:"input";s:7:"#444444";s:8:"input_bg";s:7:"#ffffff";s:5:"title";s:11:"Grid Colors";s:22:"alternative_background";s:7:"#0A242E";s:9:"text_link";s:7:"#444444";s:10:"text_hover";s:7:"#009de0";}s:16:"ts_0020000000041";a:15:{s:10:"background";s:22:"rgba(255,255,255,0.46)";s:6:"theme1";s:17:"rgba(235,76,30,1)";s:6:"theme2";s:7:"#ffffff";s:6:"theme3";s:7:"#ffffff";s:6:"border";s:13:"rgba(0,0,0,1)";s:4:"text";s:7:"#ffffff";s:4:"meta";s:7:"#ffffff";s:4:"link";s:7:"#e7e6eb";s:5:"hover";s:13:"rgba(0,0,0,1)";s:5:"input";s:7:"#e8e6e6";s:8:"input_bg";s:7:"#ffffff";s:5:"title";s:13:"Slider Colors";s:22:"alternative_background";s:7:"#F1F1F1";s:9:"text_link";s:7:"#ffffff";s:10:"text_hover";s:7:"#009de0";}s:16:"ts_0020000000080";a:15:{s:10:"background";s:7:"#0A242E";s:6:"theme1";s:7:"#0d404f";s:6:"theme2";s:7:"#f0f0f0";s:6:"theme3";s:7:"#ffffff";s:6:"border";s:19:"rgba(255,255,255,1)";s:4:"text";s:19:"rgba(247,247,247,1)";s:4:"meta";s:7:"#ffffff";s:4:"link";s:19:"rgba(255,255,255,1)";s:5:"hover";s:7:"#cfd4e8";s:5:"input";s:7:"#444444";s:8:"input_bg";s:7:"#ffffff";s:5:"title";s:13:"Footer Colors";s:22:"alternative_background";s:7:"#0A242E";s:9:"text_link";s:7:"#444444";s:10:"text_hover";s:7:"#009de0";}}';
    
    $defaultOptions[JAW_OPTIONS] = 'a:300:{s:9:"wide_mode";s:4:"wide";s:12:"custom_width";s:4:"1180";s:10:"responsive";s:1:"1";s:14:"custom_favicon";s:0:"";s:19:"global_header_style";s:10:"bar_type_3";s:12:"isotope_grid";s:1:"1";s:14:"image_cropping";s:1:"1";s:18:"scroll_load_images";s:1:"0";s:17:"image_placeholder";s:1:"1";s:23:"image_hover_effect_type";s:6:"zoomie";s:21:"image_hover_effect_bg";s:7:"#ffffff";s:20:"image_caption_toggle";s:1:"1";s:10:"totop_show";s:6:"tablet";s:12:"switch_udate";s:1:"1";s:18:"theme_revoComposer";s:1:"1";s:7:"hide_wp";s:1:"0";s:21:"user_bar_login_pageid";s:2:"84";s:27:"user_bar_wrong_login_pageid";s:2:"85";s:22:"user_bar_logout_pageid";s:2:"86";s:11:"use_jaw_seo";s:1:"0";s:16:"use_jaw_seo_logo";s:1:"1";s:13:"use_tel_links";s:1:"1";s:12:"header_color";s:0:"";s:16:"header_fullwidth";s:2:"on";s:12:"header_style";s:3:"l-a";s:15:"header_bar_type";s:8:"_default";s:11:"custom_logo";s:0:"";s:22:"custom_logo_fixed_menu";s:0:"";s:18:"custom_mobile_logo";s:0:"";s:17:"logo_retina_ready";s:1:"1";s:12:"top_bar_show";s:1:"0";s:13:"top_bar_color";s:16:"ts_0020000000020";s:17:"top_bar_fullwidth";s:2:"on";s:11:"top_bar_fix";s:1:"0";s:12:"top_bar_date";s:6:"tablet";s:19:"top_bar_date_format";s:6:"F j, Y";s:12:"top_bar_text";s:1:"0";s:20:"top_bar_text_content";s:0:"";s:12:"top_bar_menu";s:1:"0";s:14:"top_bar_social";s:1:"0";s:23:"top_bar_social_facebook";s:1:"#";s:22:"top_bar_social_twitter";s:1:"#";s:21:"top_bar_social_google";s:1:"#";s:22:"top_bar_social_youtube";s:0:"";s:20:"top_bar_social_vimeo";s:0:"";s:23:"top_bar_social_linkedin";s:0:"";s:24:"top_bar_social_pinterest";s:1:"#";s:24:"top_bar_social_instagram";s:0:"";s:20:"top_bar_user_content";s:1:"0";s:14:"top_bar_search";s:1:"0";s:20:"header_featured_show";s:3:"off";s:10:"menu_color";s:16:"ts_0020000000020";s:15:"menu_style_type";s:7:"classic";s:10:"menu_align";s:7:"justify";s:14:"menu_fullwidth";s:11:"on-shrinked";s:12:"menu_bar_fix";s:1:"2";s:20:"logo_in_menu_bar_fix";s:1:"0";s:15:"menu_left_color";s:0:"";s:14:"use_user_panel";s:1:"1";s:17:"user-panel-search";s:1:"1";s:25:"user-panel-submit-message";s:1:"0";s:31:"user-panel-submit-message-style";s:14:"Submit a Video";s:34:"user-panel-submit-message-modal_id";s:2:"93";s:13:"submenu_color";s:16:"ts_0020000000021";s:17:"mobile_menu_color";s:0:"";s:19:"mobile_menu_bar_fix";s:1:"0";s:22:"mobile_menu_show_login";s:1:"1";s:23:"mobile_menu_show_search";s:1:"1";s:15:"blog_breadcrumb";s:1:"1";s:18:"breadcrumb_bar_fix";s:1:"0";s:20:"breadcrumb_show_home";s:1:"1";s:23:"breadcrumb_show_article";s:1:"1";s:19:"blog_cut_breadcrumb";s:3:"120";s:16:"page_breadcrumbs";s:1:"0";s:13:"featured_show";s:3:"off";s:12:"footer_color";s:16:"ts_0020000000080";s:16:"footer_fullwidth";s:2:"on";s:12:"footer_style";s:9:"footer-12";s:15:"footer_bar_type";s:8:"_default";s:22:"show_centered_elements";s:3:"off";s:14:"show_copyright";s:2:"on";s:15:"show_responsive";s:1:"1";s:11:"footer_text";s:114:"<a href="http://www.jawtemplates.com/wordpress-themes/gday-news-magazine/">Copyright (c) 2016 Jawtemplates.com</a>";s:13:"my_news_color";s:16:"ts_0020000000020";s:19:"user_account_pageid";s:2:"87";s:19:"user_interest_posts";s:1:"4";s:21:"user_interest_columns";s:1:"2";s:24:"user_interest_boxes_type";s:8:"vertical";s:34:"user_interest_letter_excerpt_title";s:2:"-1";s:28:"user_interest_letter_excerpt";s:1:"0";s:26:"user_comments_number_posts";s:1:"5";s:30:"user_reading_list_number_posts";s:1:"5";s:26:"user_bar_reading_list_page";s:2:"88";s:18:"user_history_posts";s:1:"4";s:20:"user_history_columns";s:1:"3";s:23:"user_history_boxes_type";s:6:"simple";s:33:"user_history_letter_excerpt_title";s:2:"-1";s:27:"user_history_letter_excerpt";s:2:"-1";s:14:"archive_preset";s:16:"ts_0020100000000";s:12:"excerpt_text";s:3:"...";s:13:"show_readmore";s:1:"0";s:13:"readmore_text";s:9:"Read more";s:11:"blog_preset";s:16:"ts_0020100000000";s:10:"blog_order";s:4:"desc";s:12:"blog_orderby";s:4:"date";s:13:"single_preset";s:16:"ts_0020200000001";s:27:"related_post_primary_source";s:4:"cats";s:11:"showup_post";s:4:"true";s:12:"showup_video";s:1:"1";s:16:"prevnextnav_show";s:4:"true";s:25:"prevnextnav_excerpt_title";s:2:"50";s:18:"prevnextnav_thumbs";s:1:"1";s:16:"prevnextnav_meta";s:1:"1";s:13:"post_share_tw";s:1:"1";s:13:"post_share_fb";s:1:"1";s:12:"post_share_g";s:1:"1";s:13:"post_share_pi";s:1:"1";s:13:"post_share_re";s:1:"0";s:15:"post_share_mail";s:1:"1";s:23:"post_share_mail_content";s:25:"youremail@addresshere.com";s:17:"fbcomments_switch";s:1:"0";s:26:"fbcomments_nuberofcomments";s:1:"5";s:24:"comments_antispam_toggle";s:1:"1";s:26:"comments_antispam_question";s:4:"1+1=";s:24:"comments_antispam_answer";s:1:"2";s:20:"rating_maximal_value";s:1:"5";s:25:"rating_maximal_value_show";s:1:"1";s:8:"tweet_me";s:1:"1";s:12:"tweet_me_img";s:0:"";s:19:"media_gallery_color";s:16:"ts_0020000000090";s:17:"gallery_embed_pic";s:0:"";s:17:"sidebars_bar_type";s:8:"_default";s:14:"fixed_sidebars";s:8:"fixed_on";s:16:"background_image";s:0:"";s:21:"background_image_size";s:5:"cover";s:23:"background_image_repeat";s:9:"no-repeat";s:27:"background_image_attachment";s:5:"fixed";s:24:"background_image_pattern";s:10:"no-pattern";s:18:"background_texture";s:8:"none.png";s:19:"body_background_clr";s:7:"#ffffff";s:23:"body_box_background_clr";s:7:"#ffffff";s:10:"main_color";s:16:"ts_0020000000000";s:14:"success_box_bg";s:7:"#dff0d8";s:15:"success_box_clr";s:7:"#3c763d";s:11:"info_box_bg";s:7:"#d9edf7";s:12:"info_box_clr";s:7:"#31708f";s:14:"warning_box_bg";s:7:"#fcf8e3";s:15:"warning_box_clr";s:7:"#8a6d3b";s:13:"danger_box_bg";s:7:"#f2dede";s:14:"danger_box_clr";s:7:"#a94442";s:13:"overlay_upper";s:13:"rgba(0,0,0,0)";s:14:"overlay_bottom";s:15:"rgba(0,0,0,0.7)";s:12:"overlay_text";s:21:"rgba(255,255,255,0.7)";s:13:"overlay_color";s:16:"rgba(0,0,0,0.30)";s:21:"big_title_line_weight";s:1:"0";s:19:"title_4_line_weight";s:1:"1";s:18:"font_settings_mode";s:9:"classical";s:12:"font_manager";s:3208:"[{"id":"ts_1442921808911","family":"Source Sans Pro","name":"22 / 400 Source Sans Pro","source":"google","weight":"400","size":"22px","lineHeight":"1.5em","websafe":"serif","places":["topbar_menu_font","pagination_font","label_font","post_box_specialbig_font"]},{"id":"ts_1442566412183","family":"Source Sans Pro","name":"16 / 400 Source Sans Pro","source":"google","weight":"400","size":"16px","lineHeight":"1.5em","websafe":"serif","places":["menu_font","text_font","buttons_font","blockquote_font","h5_font","slider_2_font"]},{"id":"ts_1442567689873","family":"Source Sans Pro","name":"14 / 400 Source Sans Pro","source":"google","weight":"400","size":"14px","lineHeight":"1.5em","websafe":"serif","places":["topbar_font","breadcrumbs_font","submenu_font","mobilemenu_font","titles_left_boder_font","titles_middle_boder_font","titles_top_bottom_border_font","titles_background_font","h6_font","footer_font"]},{"id":"ts_1442913615920","family":"Poppins","name":"28 / 500 Poppins","source":"google","weight":"500","size":"28px","lineHeight":"1.4em","websafe":"serif","places":["big_titles_font","post_titles_font","post_box_big_font","grid_big_font"]},{"id":"ts_1442913986253","family":"Poppins","name":"22 / 500 Poppins","source":"google","weight":"500","size":"22px","lineHeight":"1.4em","websafe":"serif","places":["h2_font","grid_small_font"]},{"id":"ts_1442914212675","family":"Poppins","name":"13 / 500 Poppins","source":"google","weight":"500","size":"14px","lineHeight":"1.4em","websafe":"serif","places":["h3_font","post_box_simple_font","post_box_vertical_small_font","post_box_special_font","slider3_small_font"]},{"id":"ts_1442914476529","family":"Poppins","name":"18 / 500 Poppins","source":"google","weight":"500","size":"18px","lineHeight":"1.5em","websafe":"serif","places":["h4_font","slider3_font","fullwidth_slider_font"]},{"id":"ts_1442914684855","family":"Poppins","name":"22 / 500 Poppins","source":"google","weight":"500","size":"22px","lineHeight":"1.3em","websafe":"serif","places":["post_box_classical_font","mobile_post_box_vertical_font"]},{"id":"ts_1442928199548","family":"Poppins","name":"12 / 300 Poppins","source":"google","weight":"300","size":"12px","lineHeight":"1.4em","websafe":"serif","places":["meta_font"]},{"id":"ts_1449833687674","family":"Poppins","name":"17 / 500 Poppins","source":"google","weight":"500","size":"17px","lineHeight":"1.4em","websafe":"serif","places":["slider5_small_font"]},{"id":"ts_1453816982272","family":"Poppins","name":"30 / 500 Poppins","source":"google","weight":"500","size":"30px","lineHeight":"1.5em","websafe":"serif","places":["slider5_font"]},{"id":"ts_1453816644116","family":"Poppins","name":"19 / 500 PoppinsXX","source":"google","weight":"500","size":"19px","lineHeight":"1.3em","websafe":"serif","places":["post_box_vertical_font"]},{"id":"ts_1458057586595","family":"Source Sans Pro","name":"16 / 400 Source Sans Pro","source":"google","weight":"400","size":"16px","lineHeight":"1.3em","websafe":"serif","places":["post_box_excerpt_font"]},{"id":"ts_1464112885461","family":"Poppins","name":"Click and Name it here","source":"google","weight":"600","size":"36px","lineHeight":"1.3em","websafe":"serif","places":["h1_font"]}]";s:21:"font_mobile_paragraph";s:1:"1";s:20:"preload_google_fonts";s:1:"0";s:13:"latin_support";s:1:"0";s:17:"latin-ext_support";s:1:"0";s:16:"cyrillic_support";s:1:"0";s:20:"cyrillic-ext_support";s:1:"0";s:13:"greek_support";s:1:"0";s:17:"greek-ext_support";s:1:"0";s:18:"devanagari_support";s:1:"0";s:18:"vietnamese_support";s:1:"0";s:14:"khemer_support";s:1:"0";s:10:"custom_css";s:0:"";s:18:"custom_css_desktop";s:0:"";s:17:"custom_css_tablet";s:0:"";s:17:"custom_css_mobile";s:0:"";s:20:"custom_js_tag_header";s:17:"<script></script>";s:20:"custom_js_tag_footer";s:17:"<script></script>";s:16:"custom_js_header";s:0:"";s:9:"custom_js";s:0:"";s:16:"google_analytics";s:0:"";s:22:"background_banner_show";s:1:"0";s:17:"background_banner";s:0:"";s:34:"background_banner_image_attachment";s:5:"fixed";s:24:"background_banner_target";s:6:"_blank";s:27:"background_banner_link_left";s:1:"#";s:33:"background_banner_link_width_left";s:0:"";s:28:"background_banner_link_right";s:1:"#";s:34:"background_banner_link_width_right";s:0:"";s:18:"banner_leader_show";s:1:"0";s:19:"banner_leader_image";s:0:"";s:18:"banner_leader_link";s:1:"#";s:25:"banner_leader_link_target";s:6:"_blank";s:20:"banner_leader_google";s:0:"";s:40:"banner_skyscrapper_right_show_on_devices";s:7:"desktop";s:29:"banner_skyscrapper_right_show";s:1:"0";s:30:"banner_skyscrapper_right_image";s:0:"";s:29:"banner_skyscrapper_right_link";s:1:"#";s:36:"banner_skyscrapper_right_link_target";s:6:"_blank";s:31:"banner_skyscrapper_right_google";s:0:"";s:39:"banner_skyscrapper_left_show_on_devices";s:7:"desktop";s:28:"banner_skyscrapper_left_show";s:1:"0";s:29:"banner_skyscrapper_left_image";s:0:"";s:28:"banner_skyscrapper_left_link";s:1:"#";s:35:"banner_skyscrapper_left_link_target";s:6:"_blank";s:30:"banner_skyscrapper_left_google";s:0:"";s:32:"banner_in_header_show_on_devices";s:6:"tablet";s:21:"banner_in_header_show";s:5:"image";s:22:"banner_in_header_image";s:0:"";s:21:"banner_in_header_link";s:1:"#";s:28:"banner_in_header_link_target";s:6:"_blank";s:23:"banner_in_header_google";s:0:"";s:30:"banner_posttop_show_on_devices";s:6:"tablet";s:19:"banner_posttop_show";s:5:"image";s:20:"banner_posttop_image";s:0:"";s:19:"banner_posttop_link";s:1:"#";s:21:"banner_posttop_target";s:6:"_blank";s:21:"banner_posttop_google";s:0:"";s:33:"banner_postbottom_show_on_devices";s:6:"tablet";s:22:"banner_postbottom_show";s:5:"image";s:23:"banner_postbottom_image";s:0:"";s:22:"banner_postbottom_link";s:1:"#";s:24:"banner_postbottom_target";s:6:"_blank";s:24:"banner_postbottom_google";s:0:"";s:31:"banner_custom_1_show_on_devices";s:5:"phone";s:20:"banner_custom_1_show";s:5:"image";s:21:"banner_custom_1_image";s:0:"";s:20:"banner_custom_1_link";s:1:"#";s:22:"banner_w_1_link_target";s:6:"_blank";s:22:"banner_custom_1_google";s:0:"";s:31:"banner_custom_2_show_on_devices";s:5:"phone";s:20:"banner_custom_2_show";s:5:"image";s:21:"banner_custom_2_image";s:0:"";s:20:"banner_custom_2_link";s:1:"#";s:22:"banner_w_2_link_target";s:6:"_blank";s:22:"banner_custom_2_google";s:0:"";s:31:"banner_custom_3_show_on_devices";s:6:"tablet";s:20:"banner_custom_3_show";s:5:"image";s:21:"banner_custom_3_image";s:0:"";s:20:"banner_custom_3_link";s:1:"#";s:22:"banner_w_3_link_target";s:6:"_blank";s:22:"banner_custom_3_google";s:0:"";s:31:"banner_custom_4_show_on_devices";s:5:"phone";s:20:"banner_custom_4_show";s:5:"image";s:21:"banner_custom_4_image";s:0:"";s:20:"banner_custom_4_link";s:1:"#";s:22:"banner_w_4_link_target";s:6:"_blank";s:22:"banner_custom_4_google";s:0:"";s:31:"banner_custom_5_show_on_devices";s:5:"phone";s:20:"banner_custom_5_show";s:5:"image";s:21:"banner_custom_5_image";s:0:"";s:20:"banner_custom_5_link";s:1:"#";s:22:"banner_w_5_link_target";s:6:"_blank";s:22:"banner_custom_5_google";s:0:"";s:31:"banner_custom_6_show_on_devices";s:5:"phone";s:20:"banner_custom_6_show";s:5:"image";s:21:"banner_custom_6_image";s:0:"";s:20:"banner_custom_6_link";s:1:"#";s:22:"banner_w_6_link_target";s:6:"_blank";s:22:"banner_custom_6_google";s:0:"";s:31:"banner_custom_7_show_on_devices";s:6:"tablet";s:20:"banner_custom_7_show";s:5:"image";s:21:"banner_custom_7_image";s:0:"";s:20:"banner_custom_7_link";s:1:"#";s:22:"banner_w_7_link_target";s:6:"_blank";s:22:"banner_custom_7_google";s:0:"";s:31:"banner_custom_8_show_on_devices";s:6:"tablet";s:20:"banner_custom_8_show";s:5:"image";s:21:"banner_custom_8_image";s:0:"";s:20:"banner_custom_8_link";s:1:"#";s:22:"banner_w_8_link_target";s:6:"_blank";s:22:"banner_custom_8_google";s:0:"";s:31:"banner_custom_9_show_on_devices";s:6:"tablet";s:20:"banner_custom_9_show";s:5:"image";s:21:"banner_custom_9_image";s:0:"";s:20:"banner_custom_9_link";s:1:"#";s:22:"banner_w_9_link_target";s:6:"_blank";s:22:"banner_custom_9_google";s:0:"";s:32:"banner_custom_10_show_on_devices";s:5:"phone";s:21:"banner_custom_10_show";s:5:"image";s:22:"banner_custom_10_image";s:0:"";s:21:"banner_custom_10_link";s:1:"#";s:23:"banner_w_10_link_target";s:6:"_blank";s:23:"banner_custom_10_google";s:0:"";s:30:"banner_gallery_show_on_devices";s:6:"tablet";s:19:"banner_gallery_show";s:5:"image";s:20:"banner_gallery_fixed";s:1:"1";s:14:"banner_gallery";s:0:"";s:19:"banner_gallery_link";s:0:"";s:26:"banner_gallery_link_target";s:6:"_blank";s:21:"banner_gallery_google";s:0:"";s:31:"banner_postside_show_on_devices";s:7:"desktop";s:20:"banner_postside_show";s:5:"image";s:21:"banner_postside_image";s:0:"";s:20:"banner_postside_link";s:1:"#";s:27:"banner_postside_link_target";s:6:"_blank";s:22:"banner_postside_google";s:0:"";s:17:"error_custom_html";s:0:"";s:5:"cache";s:1:"0";s:15:"cache_time_slow";s:4:"1440";s:15:"cache_time_fast";s:3:"300";s:15:"use_translation";s:1:"0";s:8:"sidebars";s:158:"{"mensmag-homepage":"Mens mag Homepage","mensmag-homepage-2":"Mens mag Homepage","videochanel-sidebar":"Video channel","category-1":"Category/Single Sidebar"}";}';
// 

// 
    
    // pop up maker welcome page
    $defaultOptions['fs_popup-maker_activated'] = '0';
    
    // Ulozeni informace o tom ze nastaveni po prvnim stupsteni jiz probehly.
    $defaultOptions['jaw_install'] = '1';
    
    foreach($defaultOptions as $optKey => $optVal){
        if(get_option($optKey) === false){
            //pokud Optiona neni nastavena
            update_option($optKey, maybe_unserialize($optVal));
        }
    }
    jwOpt::refresh_options();
    do_action('jaw_generate_styles', 'color_preview');
    delete_transient( JAW_THEMESLUG.'_g_fonts' );
}

function jaw_remove_wp_ver_css_js( $src ) {
    if ( strpos( $src, 'ver=' ) )
        $src = remove_query_arg( 'ver', $src );
    return $src;
}

/* BBPRESS */
function jaw_get_topic_tag_list($args){
    $args['sep'] = '';
    return $args;
}
add_filter( 'bbp_before_get_topic_tag_list_parse_args', 'jaw_get_topic_tag_list' );


/* ===========================================================================================
*                                          JAW FILTERS
* ==========================================================================================*/

function jaw_crop_excerpt($content, $length = -1){
    $content = jwUtils::crop_length($content, $length);
    if(jwOpt::get_option('show_readmore',0)){
        $content = $content.' <a href="'.get_the_permalink().'">'.jwOpt::get_option('readmore_text').'</a>';
    }
    return $content;
}
add_filter('jaw_excerpt', 'jaw_crop_excerpt',10,2);

function jaw_gallery_title_name() {
    return esc_html__("gallery",'gdn-theme');
}
add_filter("jaw_gallery_box_default_name","jaw_gallery_title_name");

/* ===========================================================================================
*                                          JAW ACTIONS
* ==========================================================================================*/

function jaw_generate_styles($type = "color"){
    $jwStyle = new jwStyle();
    $jwStyle->get_static($type);
}
function jaw_deregister_generate_styles(){
    remove_action('jaw_generate_styles', 'jaw_generate_styles', 10, 1);
}
 
// php version checker
function jaw_compare_php_versions() {
    ?>
    <div class="notice notice-warning is-dismissible">
        <p><?php esc_html_e("Please contact your hosting company to update php to version 5.4 at least. Thank you. Your current version is: ",'gdn-theme'); PHP_VERSION ?> </p>
    </div>
    <?php
}
if(version_compare(PHP_VERSION, '5.4.0') < 0) {
    add_action( 'admin_notices', 'jaw_compare_php_versions' );
}


/* ===========================================================================================
*                                          JAW COMPATIBILITIES FOR 3RD PARTY PLUGINS
* ==========================================================================================*/

// MASHSHARE PLUGIN
if (class_exists('mashshare')) {
    
    add_action( 'after_setup_theme', 'jaw_mashsharer_disable_welcome_redirect' );
    add_action( 'init', 'jaw_mashsharer_register_new_networks' );
    
    add_filter( 'mashsb_array_networks', 'jaw_mashsharer_array_networks' );
    
    function jaw_mashsharer_array_networks( $array ) {
        global $mashsb_options, $post;
        $singular = isset( $mashsb_options['singular'] ) ? $singular = true : $singular = false;

        $url = $array['url'];
        $title = $array['title'];
        $whatsapp_title = str_replace('+', '%20', $title);

        
        !empty($mashsb_options['mashnet_subjecttext']) ? $subject = rawurlencode($mashsb_options['mashnet_subjecttext']) : $subject = '%20';
        !empty($mashsb_options['mashnet_bodytext']) ? $body = rawurlencode($mashsb_options['mashnet_bodytext']) : $body = '%20';

    $networkArray = array(
        'google' => 'https://plus.google.com/share?text=' . $title . '&amp;url=' . $url,
        'whatsapp' =>  'whatsapp://send?text=' . $whatsapp_title . '%20' . $url,
        'pinterest' => 'https://pinterest.com/pin/create/button/?url=' . $url . '&amp;media=' . urlencode(jaw_mashnet_get_pinterest_image()) . '&amp;description=' . urlencode(jaw_mashnet_get_pinterest_desc()),
        'digg' => 'http://digg.com/submit?phase=2%20&amp;url=' . $url . '&amp;title=' . $title,
        'linkedin' => 'https://www.linkedin.com/shareArticle?trk=' . $title . '&amp;url=' . $url,
        'linkedin ' => 'https://www.linkedin.com/shareArticle?trk=' . $title . '&amp;url=' . $url, // Blank character fix ()
        'reddit' => 'http://www.reddit.com/submit?url=' . $url . '&amp;title=' . $title, 
        'reddit ' => 'http://www.reddit.com/submit?url=' . $url . '&amp;title=' . $title, // Blank character fix ()
        'stumbleupon' => 'http://www.stumbleupon.com/submit?url=' . $url,
        'stumbleupon ' => 'http://www.stumbleupon.com/submit?url=' . $url, // Blank character fix ()
        'vk' => 'http://vkontakte.ru/share.php?url=' . $url . '&amp;item=' . $title,
        'print' => 'http://www.printfriendly.com/print/?url=' . $url . '&amp;item=' . $title,
        'delicious' => 'https://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=' . $url . '&amp;title=' . $title,
        'buffer' => 'https://bufferapp.com/add?url=' . $url . '&amp;text=' . $title,
        'weibo' => 'http://service.weibo.com/share/share.php?url=' . $url . '&amp;title=' . $title,
        'pocket' => 'https://getpocket.com/save?title=' . $title . '&amp;url=' . $url,
        'xing' => 'https://www.xing.com/social_plugins/share?h=1;url=' . $url . '&amp;title=' . $title,
        'tumblr' => 'https://www.tumblr.com/share?v=3&amp;u='. $url . '&amp;t=' . $title,
        'mail' => 'mailto:?subject=' . $subject . '&amp;body=' . $body . $url,
        'meneame' => 'http://www.meneame.net/submit.php?url=' . $url . '&amp;title=' . $title,
        'odnoklassniki' => 'http://www.odnoklassniki.ru/dk?st.cmd=addShare&amp;st.s=1&amp;st._surl=' . $url . '&amp;title=' . $title,
        'managewp' => 'http://managewp.org/share/form?url=' . $url . '&amp;title=' . $title,
        'mailru' => 'http://connect.mail.ru/share?share_url=' . $url,
        'line' => 'http://line.me/R/msg/text/?' . $title .'%20'. $url,
        'yummly' => 'http://www.yummly.com/urb/verify?url=' . $url . '&amp;title=' . $title,
        'frype' => 'http://www.draugiem.lv/say/ext/add.php?title='. $title .'&amp;link='.$url,
        'skype' => 'https://web.skype.com/share?url='.$url.'&lang=en-en',
        'telegram' => 'https://telegram.me/share/url?url='.$url.'&text=' . $title,
        'flipboard' => 'https://share.flipboard.com/bookmarklet/popout?v=2&title=' . urlencode($title) . '&url=' . $url,
        'hackernews' => 'http://news.ycombinator.com/submitlink?u='.$url.'&t='.urlencode($title),
        );
        return array_merge($array, $networkArray); 
    }

    /**
    * Get Pinterest image
    * 
    * @global obj $mashsb_meta_tags
    * @return string
    */
    function jaw_mashnet_get_pinterest_image() {
        global $post, $mashsb_meta_tags;
        if( is_singular() && class_exists( 'MASHSB_HEADER_META_TAGS' ) && method_exists($mashsb_meta_tags, 'get_pinterest_image_url') ) {
            $image =  $mashsb_meta_tags->get_pinterest_image_url();
        }else{
            $image = function_exists( 'MASHOG' ) ? MASHOG()->MASHOG_OG_Output->_add_image() : mashsb_get_image( $post->ID );
        }
        return $image;
    }

    /**
    * Get Pinterest description
    * 
    * @global obj $mashsb_meta_tags
    * @return type
    */
    function jaw_mashnet_get_pinterest_desc() {
        global $post, $mashsb_meta_tags;
        if( is_singular() && class_exists( 'MASHSB_HEADER_META_TAGS' ) && method_exists($mashsb_meta_tags, 'get_pinterest_description') ) {
            global $mashsb_meta_tags;
            return $mashsb_meta_tags->get_pinterest_description();
        } else{
            return mashsb_get_excerpt_by_id($post);
        }
    }
    
    /**
    * Register custom networks
    */
    function jaw_mashsharer_register_new_networks() {
        $networks = get_option( 'mashsb_networks' );
        if ( ! in_array( 'Google', $networks, true ) ) {
            $networks[] = 'Google';
        }
        if ( ! in_array( 'Pinterest', $networks, true ) ) {
            $networks[] = 'Pinterest';
        }
        if ( ! in_array( 'Reddit', $networks, true ) ) {
            $networks[] = 'Reddit';
        }
        if ( ! in_array( 'Tumblr', $networks, true ) ) {
            $networks[] = 'Tumblr';
        }
        update_option( 'mashsb_networks', $networks );
    }
    
    /**
    * Class MashshareNetworks
    */
    if ( ! class_exists( 'MashshareNetworks' ) ) {
        class MashshareNetworks {
            // This class is required to enable custom networks counting.
            // It won't be used if "MashshareNetworks" add-on is installed.
        }
    }
    
    /**
    * Disable MashShare welcome page redirect.
    */
    function jaw_mashsharer_disable_welcome_redirect() {
        delete_transient( '_mashsb_activation_redirect' );
    }
    
}
/*=======================================END================================================*/

// 
function jaw_lite_notice() {
    ?>
    <div class="notice notice-warning">
        <p>This is LITE version of <strong>GDN Magazine theme</strong>. Check PRO version <a href="https://themeforest.net/item/gdn-magazine-theme/16897309?ref=jawtemplates">HERE</a></p>
    </div>
    <?php
}
function jaw_lite_notice_ad() {
    ?>
    <div class="notice notice-warning">
    <p style="text-align: center;"><a href="https://www.wordpress-themes.market/"><img class="alignalignnone wp-image-2635 size-full" src="http://demo.jawtemplates.com/goodstore/wp-content/uploads/2014/06/best-themes-collectiom-market.png" alt="Best Theme Collection 2017" width="360" height="100"></a><br><a href="https://www.wordpress-themes.market/" target="_blank">WordPress Themes Market 2017</a></p>
    </div>
    <?php
}
add_action('admin_notices', 'jaw_lite_notice_ad');
add_action('admin_notices', 'jaw_lite_notice');
// 