/* JAW Gallery */
(function($, window) {
    JawApp.prototype.gallery = {
        init: function() {
            $(".jaw-media-gallery").show();
            // vars
            var position = 0,
                loading_interval = 0,
                src = [],
                img_list = [],
                key_word = "",
                clicked = "",
                actual_description_id = "",
                show_animation = "",
                loader = "<div class=\'animation\'><div id=\'circleG\'><div id=\'circleG_1\' class=\'circleG\'></div><div id=\'circleG_2\' class=\'circleG\'></div><div id=\'circleG_3\' class=\'circleG\'></div></div></div>",
                main_image = ".jaw-media-gallery .inner-container .item-wrapper img",
                main_video = ".jaw-media-gallery .inner-container .item-wrapper.video_link",
                main_embed = ".jaw-media-gallery .inner-container .item-wrapper.embed_link",
                main_image_list = ".jaw-gallery-image-pagination4 .img-list-ind",
                main_pagination_link = ".jaw-media-gallery a#jaw-gallery-image-pagination-link-",
                main_image_description = ".jaw-media-gallery a.jaw-gallery-image-pagination-link,.jaw-media-gallery p.jaw-gallery-description",
                main_single_image = ".jaw-media-gallery p#jaw-gallery-single-image-",
                main_window = "",
                img_banner_top_h = 0,
                imglist_class='12-7',
                prettyphoto = 0,
                // url storing
                actual_url_img,
                originalURLParse="",
                dynamic_url = [], // actual img url
                // @MASHARE and Social STUFF
                checker, // check for the first url loaded (for @mashare plugin)
                urldef = [], // parse first url loaded (for @mashare plugin)
                socialContainer = ".single-jaw-gallery .mashsb-box, .single-jaw-gallery .share_post", // main container contains social el(s)
                socialItems = ".mashsb-buttons a, .share_post .socialshare-icon a"; // contains items for url parsing
                // @MASHARE and Social END
            // JAW SEO
            function setSeoImgURL() {
                var descImg="";
                var titleImg="";
                if($(".jaw-gallery-main-title .main_title").length > 0) {
                    titleImg=$(".jaw-gallery-main-title .main_title").text();
                }
                var srcImg = new Image();
                srcImg.src = $(".jaw-gallery-single-img-container img").attr("src");
                if($( ".jaw-shadow p" ).text().length > 0) {
                    descImg = $( ".jaw-shadow p" ).text();
                }
                $("meta[property='og:url'],meta[property='og:description'],meta[property='og:image'],meta[property='og:image:width'],meta[property='og:image:height'],meta[property='og:title']").remove();
                
                $('head').append( '<meta property="og:title" content="'+titleImg+'">' );
                $('head').append( '<meta property="og:url" content="'+window.location.href+'">' );
                $('head').append( '<meta property="og:description" content="'+descImg+'">' );
                $('head').append( '<meta property="og:image" content="'+srcImg.src+'">' );
                $('head').append( '<meta property="og:image:width" content="'+srcImg.naturalWidth+'">' );
                $('head').append( '<meta property="og:image:height" content="'+srcImg.naturalHeight+'">' );
            }
            // get url params and its values
            function get_url_param() {
                var vars = [], hash;
                var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
                for(var i = 0; i < hashes.length; i++) {
                    hash = hashes[i].split('=');
                    vars.push(hash[0]);
                    vars[hash[0]] = hash[1];
                }
                dynamic_url = vars;
                if(vars['imid'] != null && vars['imid'] > 0 && vars['imid'] <= Number(src.length)) {
                    return ((vars['imid']) - 1);
                } else {
                    return '';
                }
            }
            // Show specific img url after click
            function get_dynamic_img_url() { // 17.5.2016
                if(dynamic_url[0] == "poid") {
                    actual_url_img = "?"+dynamic_url[0]+"="+dynamic_url["poid"]+"&imid="+(Number(position)+Number(1));
                    // @mashare url
                    if($(socialContainer).length) {
                        if(checker == 0) { // we need to store urls first
                            $(socialItems).each(function (key, element) {
                                urldef[key]=$(this).attr("href");
                                $(this).attr("href",urldef[key]+actual_url_img);
                            });
                        } else { // then use the first stored urls here (just the same first urls)
                            $(socialItems).each(function (key, element) {
                                var parse=urldef[key]+actual_url_img;
                                var subparse = parse.split("?");
                                parse = subparse.splice(0, subparse.length-1).join("?"); // pokud je vice jak jedna shoda (poid...), vymaze se posledni z pole
                                parse = parse.replace(originalURLParse,actual_url_img); // vymenit statickou za dynamicky menici se url
                                parse = parse.replace("??","?"); // firefox issue fixed
                                $(this).attr("href",parse);
                            });
                        }
                        checker++;
                    }
                    return history.replaceState('','',actual_url_img);
                } else {
                    return;
                }
            }            
            // Show only active image description
            function get_active_img_descr() {
                $('.jaw-media-gallery p.jaw-gallery-description').each(function() {
                    if (!$(this).hasClass('active')) {
                        $(this).hide();
                    } else {
                        $(this).show();
                    }
                });
            }
            // show / hide img desc
            function get_img_description() {
                // hide description after click close button
               jQuery('i.jaw-icon-square-down-left').on('click', function(e) {
                    $('.jaw-gallery .inner-container').addClass('jaw-expand-img-desc');
                    $('i.jaw-icon-square-up-right').addClass('jaw-expand-img-desc');
                });
                // show description adter click arrow button
               jQuery('i.jaw-icon-square-up-right').on('click', function(e) {
                    $('.jaw-gallery .inner-container').removeClass('jaw-expand-img-desc');
                    $('i.jaw-icon-square-up-right').removeClass('jaw-expand-img-desc');
                });
            }
            // show current image for zooming in extra window
            function show_current_image() {
                jQuery('.jaw-media-gallery .inner-container .item-wrapper .jaw-icon-expand').on('click', function() {
                    $("a[rel^='prettyPhoto'], a[data-rel^='prettyPhoto'] ").prettyPhoto({
                        social_tools: false,
                        default_width: 800,
                        default_height: 500,
                        show_title: false,
                        allow_expand: false,
                        theme: 'jaw_scheme',
                        deeplinking: false,
                        changepicturecallback: function(){
                            prettyphoto = 1; // open
                        },
                        callback: function(){
                            prettyphoto = 0; // close
                        }
                    });
                });
                // img resize
                var img_top_h = 0 ;
                var parse_width = 0;
                var uber_const = 1.78;
                jQuery('#jaw-gallery-int-animation-0 img').css("max-height",(main_window));
                if($(main_video).length) {
                    parse_width = $('.item-wrapper.video_link').attr('class').split('-')[3];
                    img_top_h = ($(main_video).offset().top);
                    $(main_video).css({"max-width":"100%","width":"100%"});
                    $(main_video).height(main_window);
                }
                if($(main_embed).length) {
                    img_top_h = ($(main_embed).offset().top);
                    parse_width = $('.item-wrapper.embed_link').attr('class').split('-')[3];
                    $(main_embed).css({"max-width":"100%","width":"100%"});
                    $(main_embed).height(main_window);
                }
                // next image after img click
                jQuery(main_image).on('click', function() {
                    position = $('.jaw-gallery-description').attr('id').split('-')[4];
                    // go back to the first content
                    if (position == src.length - 1) {
                        $(main_pagination_link + (0) + '').addClass("active");
                        position = -1;
                    } else {
                        $(main_pagination_link + (position + 1) + '').addClass("active");
                    }
                    actual_description_id = Number(actual_description_id) + 1;
                    $(main_single_image + (actual_description_id) + '').addClass('active');
                    before_image_showing();
                    jQuery.post(ajax_object.ajax_url, function(response) {
                        if (show_animation == 1) {
                            setTimeout(function() {
                                current_image_showing(src, position);
                            }, loading_interval);
                        } else {
                            current_image_showing(src, position);
                        }
                        position++;
                        image_gallery_pagination3(src, position);
                        image_gallery_pagination4(src, position);
                        $(main_image_list).removeClass("active");
                        $('#p4-' + (position) + '').addClass('active');
                        get_active_img_descr();
                        get_dynamic_img_url();
                    });
                });
                // sliding for mobile devices
                jQuery(".item-wrapper").hammer().on("swipeleft swiperight", function(ev) {
                    switch(ev.type) {
                        case "swipeleft" :
                        position = $('.jaw-gallery-description').attr('id').split('-')[4];
                        // go back to the first content
                        if (position == src.length - 1) {
                            $(main_pagination_link + (0) + '').addClass("active");
                            position = -1;
                        } else {
                            $(main_pagination_link + (position + 1) + '').addClass("active");
                        }
                        actual_description_id = Number(actual_description_id) + 1;
                        $(main_single_image + (actual_description_id) + '').addClass('active');
                           before_image_showing();
                            jQuery.post(ajax_object.ajax_url, function(response) {
                                if (show_animation == 1) {
                                    setTimeout(function() {
                                        current_image_showing(src, position);
                                    }, loading_interval);
                                } else {
                                    current_image_showing(src, position);
                                }
                                position++;
                                image_gallery_pagination3(src, position);
                                image_gallery_pagination4(src, position);
                                $(main_image_list).removeClass("active");
                                $('#p4-' + (position) + '').addClass('active');
                                get_active_img_descr();
                                get_dynamic_img_url();
                            });
                            break;
                        case "swiperight" :
                            // go back to the last content
                            if (src[position] == src[0]) {
                                $(main_pagination_link + (src.length - 1) + '').addClass("active");
                                position = src.length;
                            } else {
                                $(main_pagination_link + (position - 1) + '').addClass("active");
                            }
                            actual_description_id = Number(actual_description_id) - 1;
                            $(main_single_image + (actual_description_id) + '').addClass('active');
                            before_image_showing();
                            jQuery.post(ajax_object.ajax_url, function(response) {
                                if (show_animation == 1) {
                                    setTimeout(function() {
                                        current_image_showing(src, position);
                                    }, loading_interval);
                                } else {
                                    current_image_showing(src, position);
                                }
                                position--;
                                image_gallery_pagination3(src, position);
                                image_gallery_pagination4(src, position);
                                $(main_image_list).removeClass("active");
                                $('#p4-' + (position) + '').addClass('active');
                                get_active_img_descr();
                                get_dynamic_img_url();
                            });
                            break;
                        default:
                            break;
                    }
                });
                get_img_description();
            }
            // before ajax 
            function before_image_showing() {
                // set animation to show/hide
                show_animation = 1;
                $(".jaw-media-gallery .gallery-loader").show();
                $(".jaw-media-gallery .gallery-loader").html(loader);
            }
            // in ajax
            function current_image_showing(src, position) {
                $('.jaw-media-gallery .inner-container').html(src[position]);
                $(".jaw-media-gallery .gallery-loader").hide();
                show_current_image();
            }
            // image pagination 3
            function image_gallery_pagination3(src, position) {
                var container = $('<div class="numero"></div>');
                var actual = position;
                container.append(Number(actual) + 1 + ' \/ ' + Number(src.length));
                $('.jaw-media-gallery .jaw-gallery-image-pagination3').html(container);
            }
            // image pagination 4
            function image_gallery_pagination4(src, position) {
                var container = $('<div class="img-list-pag4"></div>');
                if($(".jaw-gallery-banner-show").length) {
                    imglist_class = '2';
                }
                for (var i = 0; i < src.length; i++) {
                    // show content
                    if (i == 0) {
                        container.append('<div id=p4-' + (i) + ' class="active col-lg-'+imglist_class+' col-md-3 col-sm-4 col-xs-12 img-list-ind">' + (img_list[i]) + '</div>');
                    } else {
                        container.append('<div id=p4-' + (i) + ' class="col-lg-'+imglist_class+' col-md-3 col-sm-4 col-xs-12 img-list-ind">' + (img_list[i]) + '</div>');
                    }
                }
                $('.jaw-gallery-image-pagination4').html(container);
                // going from special blog
                if(get_url_param().length != 0) {
                    position = get_url_param();
                    $(main_image_list).removeClass("active");
                    if ($('.jaw-gallery-image-pagination4 #p4-'+position+'').hasClass("active")) {
                        $('.jaw-gallery-image-pagination4 #p4-'+position+'').removeClass("active");
                    } else {
                        $('.jaw-gallery-image-pagination4 #p4-'+position+'').addClass("active");
                    }
                    highlight_pagination4(src);
                } else { // going from classic single post or shortcode
                    highlight_pagination4(src);
                }
            }
            //highlight active pagination 4
            function highlight_pagination4(src) {
                jQuery('.jaw-gallery-image-pagination4').on('click', '.img-list-ind', function() {
                    $("html,body").animate({ scrollTop: 0 }, "slow");
                    $(main_image_list).removeClass("active");
                    position = $(this).attr('id').split('-')[1];
                    if ($(this).hasClass("active")) {
                        $(this).removeClass("active");
                    } else {
                        $(this).addClass("active");
                    }
                    actual_description_id = position-1;
                    // print some content out
                    jQuery.post(ajax_object.ajax_url, function(response) {
                        before_image_showing();
                        if (show_animation == 1) {
                            setTimeout(function() {
                                current_image_showing(src, position);
                            }, loading_interval);
                        } else {
                            current_image_showing(src, position);
                        }
                        image_gallery_pagination3(src, position);
                        $('.jaw-media-gallery .jaw-gallery-description').removeClass('active');
                        $(main_single_image + (actual_description_id) + '').addClass('active');
                        get_active_img_descr();
                        get_dynamic_img_url();
                    });
                });
            }
            // MAIN
            if (src != null) {
                // init @mash social urls
                checker = 0;
                if(checker == 0 && $(socialContainer).length) { // we need to store urls first
                    $(socialItems).each(function (key, element) {
                        urldef[key]=$(this).attr("href");
                        $(this).attr("href",urldef[key]);
                    });
                    checker++;
                }
                // end @mash social urls
                // get original url
                originalURLParse=window.location.href.split("?")[1];
                // default view
                if(jQuery(window).width() < 768) {
                    main_window = ($(window).height()); // responsive
                } else {
                    main_window = ($(window).height() - 250); // desktop
                }
                jQuery('.jaw-gallery-single-img-container').css("height",(main_window));
                if($('.jaw-gallery-banners img').length) {
                    img_banner_top_h = ($('.jaw-gallery-banners img').offset().top);
                    jQuery('.jaw-gallery-banners .post_banner').height(jQuery(window).height() - 2*img_banner_top_h);   
                }
                // store it all
                $('.jaw-media-gallery .item').each(function() {
                    src.push($(this).html());
                });
                $('.jaw-media-gallery .item_list, .jaw-media-gallery .item_pic.embed_link_pic, .jaw-media-gallery .item_pic.video_link_pic').each(function() {
                    img_list.push($(this).html());
                });
                if(get_url_param().length != 0) {
                    position = get_url_param();
                }
                // hide items
                jQuery(".jaw-media-gallery .inner-container .item").each(function() {
                    $(this).hide();
                });
                // adding for custom image position
                if (jQuery('.ic-with-custom-int').length) {
                    loading_interval = jQuery('.ic-with-custom-int').attr('id').split('-')[4];
                    if (show_animation == 1) {
                        setTimeout(function() {
                            current_image_showing(src, position);
                            // adding for custom image position
                            jQuery(main_image_list).removeClass("active");
                            jQuery('#p4-' + (position) + '').addClass('active');
                        }, loading_interval);
                    } else {
                        current_image_showing(src, position);
                    }
                }
                // adding for custom image position
                if (jQuery('.jaw-gallery-single-img-container').length) {
                    position = jQuery('.jaw-gallery-single-img-container').attr('id').split('-')[4];
                }
                // show only active images description
                $('.jaw-media-gallery p.jaw-gallery-description').each(function() {
                    if (!$(this).hasClass('active')) {
                        $(this).hide();
                    } else {
                        actual_description_id = $('.jaw-media-gallery p.jaw-gallery-description').attr('id').split('-')[4];
                    }
                });
                if(get_url_param().length != 0) {
                    position = get_url_param();
                }
                // pagination
                image_gallery_pagination3(src, position);
                image_gallery_pagination4(src, position);
            }
            // 17.5.2016 - kvuli seo change url (after every ajax ends)
            if($('.jaw-media-gallery').length > 0) {
                $(this).ajaxComplete(function() {
                    setSeoImgURL();
                });
            }
            // content moving via keys left and right
            $(document).keydown(function(e) {
                if(prettyphoto === 0) { // prettyphoto closed
                    var prevent = "";
                    $(main_image_description).removeClass("active");
                    switch (e.which) {
                        case 39 : // do right position
                            prevent = true;
                            key_word = "right";
                            // go back to the first content
                            if (position == src.length - 1) {
                                $(main_pagination_link + (0) + '').addClass("active");
                                position = -1;
                            } else {
                                // fix - after you click on the paginations number and then press right key you have lost your active paginations number (no highlihgted number)
                                if (clicked == 1 || clicked == 2) {
                                    var pos = position;
                                    pos++;
                                    $(main_pagination_link + (pos) + '').addClass("active");
                                    clicked = 0;
                                } else {
                                    $(main_pagination_link + (position + 1) + '').addClass("active");
                                }
                            }
                            actual_description_id = Number(actual_description_id) + 1;
                            $(main_single_image + (actual_description_id) + '').addClass('active');
                            break;
                        case 37 : // do left position
                            prevent = true;
                            key_word = "left";
                            // go back to the last content
                            if (src[position] == src[0]) {
                                $(main_pagination_link + (src.length - 1) + '').addClass("active");
                                position = src.length;
                            } else {
                                $(main_pagination_link + (position - 1) + '').addClass("active");
                            }
                            actual_description_id = Number(actual_description_id) - 1;
                            $(main_single_image + (actual_description_id) + '').addClass('active');
                            break;
                        default:
                    }
                    if (prevent) {
                        before_image_showing();
                        // print some content out
                        jQuery.post(ajax_object.ajax_url, function(response) {
                            $(main_image_list).removeClass("active");
                            if (show_animation == 1) {
                                setTimeout(function() {
                                        current_image_showing(src, position);
                                }, loading_interval);
                            } else {
                                if(get_url_param().length != 0) {
                                    current_image_showing(src, position+1);
                                }
                                else {
                                    current_image_showing(src, position);
                                }
                            }
                            if (key_word == "left") {
                                if(position > 0) {
                                    position--;
                                    jQuery('#p4-' + (position) + '').addClass('active');
                                }
                            }
                            if (key_word == "right") {
                                if(position < src.length-1) {
                                    position++;
                                    jQuery('#p4-' + (position) + '').addClass('active');
                                } else {
                                    position = 0;
                                    jQuery('#p4-' + (position) + '').addClass('active');
                                }
                            }
                            image_gallery_pagination3(src, position);
                            current_image_showing(src, position);
                            get_active_img_descr();
                            get_dynamic_img_url();
                            prevent = "";
                        });
                    }
                }
            });
            // content moving via clickable arrows
            jQuery('.jaw-media-gallery .jaw-gallery-single-img-container a').on('click', function(e) {
                e.preventDefault(); // no top jumpin'
                $(main_image_description).removeClass("active");
                if ($(e.target).is('a.right') || $(e.target).is('i.jaw-icon-sipka-gallery-right') || $(e.target).is('.jaw-mobilegalleryarrow-right')) {
                    // go back to the first content
                    if (position == src.length - 1) {
                        $(main_pagination_link + (0) + '').addClass("active");
                        position = -1;
                    } else {
                        $(main_pagination_link + (position + 1) + '').addClass("active");
                    }
                    actual_description_id = Number(actual_description_id) + 1;
                    $(main_single_image + (actual_description_id) + '').addClass('active');
                }
                if ($(e.target).is('a.left') || $(e.target).is('i.jaw-icon-sipka-gallery-left') || $(e.target).is('.jaw-mobilegalleryarrow-left')) {
                    // go back to the last content
                    if (src[position] == src[0]) {
                        $(main_pagination_link + (src.length - 1) + '').addClass("active");
                        position = src.length;
                    } else {
                        $(main_pagination_link + (position - 1) + '').addClass("active");
                    }
                    actual_description_id = Number(actual_description_id) - 1;
                    $(main_single_image + (actual_description_id) + '').addClass('active');
                }
                before_image_showing();
                // print some content out
                jQuery.post(ajax_object.ajax_url, function(response) {
                    $(main_image_list).removeClass("active");
                    if (show_animation == 1) {
                        setTimeout(function() {
                            current_image_showing(src, position);
                        }, loading_interval);
                    } else {
                        if(get_url_param().length != 0) {
                            current_image_showing(src, position+1);
                        }
                        else {
                            current_image_showing(src, position);
                        }
                    }
                    if ($(e.target).is('a.right') || $(e.target).is('i.jaw-icon-sipka-gallery-right') || $(e.target).is('.jaw-mobilegalleryarrow-right')) {
                        if(position < src.length-1) {
                            position++;
                            jQuery('#p4-' + (position) + '').addClass('active');
                        } else {
                            position = 0;
                            jQuery('#p4-' + (position) + '').addClass('active');
                        }
                    }
                    if ($(e.target).is('a.left') || $(e.target).is('i.jaw-icon-sipka-gallery-left') || $(e.target).is('.jaw-mobilegalleryarrow-left')) {
                        if(position > 0) {
                            position--;
                            jQuery('#p4-' + (position) + '').addClass('active');
                        }
                    }
                    image_gallery_pagination3(src, position);
                    current_image_showing(src, position);
                    get_active_img_descr();
                    get_dynamic_img_url();
                });
            });
        }
    };
})(jQuery, window);